#include <stdio.h>
#include <dos.h>
#include <memory.h>
#include <fcntl.h>

#include "fmd.h"
#include "..\common.h"
#include "..\extern.h"

char	*FMD_ton = "*.TON";

int FMD_check( void )
{
	char	id[16];

	memset( id, 0, sizeof( id ));

	_readvect( 0x0E, 0, 2, id ); /* INT2 */

	if( memcmp( id, "UWVRQSP", 7 ) != 0 )
	{
		printf( MES[MES_DRVNOTFOUND], DRIVER_name );
		return 1;
	}

	printf( INFO[INFO_DRIVER], DRIVER_name );

	return 0;
}

int FMD_load( char *filename )
{
	struct find_t		ft;
	unsigned char far	*p;
	long				filesize;

	if( _dos_findfirst( FMD_ton, _A_NORMAL, &ft ) == 0 )
	{
		/* TON : DX:SI */
		r.x.ax = 0x0201;
		r.x.dx = FP_SEG( ft.name );
		r.x.si = FP_OFF( ft.name );
		int86x( 0xD3, &r, &ro, &sr );
	}

	filesize = _filesize( filename );
	if( filesize == -1 ) return 1;

	p = _far_calloc( filesize );
	if( p == NULL ) return 1;
	_far_fileload( filename, p );

	/* Music : DX:SI */
	r.x.ax = 0x0100;
	r.x.dx = FP_SEG( p );
	r.x.si = FP_OFF( p );
	int86x( 0xD3, &r, &ro, &sr );

	farfree( p );

	return 0;
}

int FMD_play( char *opt1, char *opt2 )
{
	r.x.ax = 0x0300;
	int86x( 0xD3, &r, &ro, &sr );

	return 0;
}

int FMD_stop( void )
{
	r.x.ax = 0x01FF;
	int86x( 0xD3, &r, &ro, &sr );

	return 0;
}
