#include <stdio.h>
#include <dos.h>
#include <memory.h>

#include "mdrv98.h"
#include "..\common.h"
#include "..\extern.h"

int MDRV98_check( void )
{
	char	id[16];

	memset( id, 0, sizeof( id ));

	_readvect( 0xF2, 1, 0x102, id );

	if( memcmp( id, "Mdrv2", 4 ) != 0 )
	{
		printf( MES[MES_DRVNOTFOUND], DRIVER_name );
		return 1;
	}

	printf( INFO[INFO_DRIVER], DRIVER_name );

	return 0;
}

int MDRV98_load( char *filename )
{
	long				filesize;
	unsigned char far	*p;

	filesize = _filesize( filename );
	if( filesize == -1 ) return 1;

	p = _far_calloc( filesize );
	_far_fileload( filename, p );

	/* Music : DS:SI */
	r.h.ah = 0x06;
	sr.ds  = FP_SEG( p );
	r.x.si = FP_OFF( p );
	int86x( 0xF2, &r, &ro, &sr );

	farfree( p );

	return 0;
}

int MDRV98_play( char *opt1, char *opt2 )
{
	r.h.ah = 0x00;
	int86x( 0xF2, &r, &ro, &sr );

	return 0;
}

int MDRV98_stop( void )
{
	r.h.ah = 0x03;
	int86x( 0xF2, &r, &ro, &sr );

	return 0;
}

int MDRV98_fade( void )
{
	r.h.ah = 0x02;
	int86x( 0xF2, &r, &ro, &sr );

	return 0;
}
