#include <stdio.h>
#include <string.h>
#include <dos.h>
#include <memory.h>
#include <fcntl.h>

#include "mmd.h"
#include "..\common.h"
#include "..\extern.h"

int MMD_check( void )
{
	char	id[16];

	memset( id, 0, sizeof( id ));
	_readvect( 0x61, 0, 2, id );

	if( memcmp( id, "MMD", 3 ) != 0 )
	{
		printf( MES[MES_DRVNOTFOUND], DRIVER_name );
		return 1;
	}

	printf( INFO[INFO_DRIVER], DRIVER_name );

	return 0;
}

int MMD_load( char *filename )
{
	unsigned char far	*p = NULL;

	/* Music : DS:DX */
	r.h.ah = 0x06;
	int86x( 0x61, &r, &ro, &sr );
	p = MK_FP(( unsigned short )sr.ds, ( unsigned short )ro.x.dx );

	if( _far_fileload( filename, p ) == -1 ) return 1;

	return 0;
}

int MMD_play( char *opt1, char *opt2 )
{
	r.h.ah = 0x00;
	int86x( 0x61, &r, &ro, &sr );

	return 0;
}

int MMD_stop( void )
{
	r.h.ah = 0x01;
	int86x( 0x61, &r, &ro, &sr );

	return 0;
}

int MMD_fade( void )
{
	r.h.ah = 0x02;
	r.h.al = 0x08;
	int86x( 0x61, &r, &ro, &sr );

	return 0;
}
