#include <stdio.h>
#include <dos.h>
#include <memory.h>
#include <fcntl.h>

#include "rx.h"
#include "..\common.h"
#include "..\extern.h"

int RX_check( void )
{
	char	id[16];

	memset( id, 0, sizeof( id ));

	_readvect( 0x42, 1, -8, id );

	if( memcmp( id, "gmpv4sp", 7 ) != 0 )
	{
		printf( MES[MES_DRVNOTFOUND], DRIVER_name );
		return 1;
	}

	printf( INFO[INFO_DRIVER], DRIVER_name );

	return 0;
}

int RX_load( char *filename )
{
	unsigned char far	*p;

	/* Music : ES:DX */
	r.h.ah = 0x06;
	int86x( 0x42, &r, &ro, &sr );
	p = MK_FP( sr.es, ro.x.dx );

	if( _far_fileload( filename, p ) == -1 ) return 1;

	return 0;
}

int RX_play( char *opt1, char *opt2 )
{
	r.h.ah = 0x00;
	int86x( 0x42, &r, &ro, &sr );

	return 0;
}

int RX_stop( void )
{
	r.h.ah = 0x01;
	int86x( 0x42, &r, &ro, &sr );

	return 0;
}

int RX_fade( void )
{
	r.x.ax = 0x0401;
	int86x( 0x42, &r, &ro, &sr );

	return 0;
}
