#include <stdio.h>
#include <string.h>
#include <dos.h>
#include <memory.h>

#include "ss.h"
#include "..\common.h"
#include "..\extern.h"

unsigned char	SS_int = 0;

int SS_check( void )
{
	char	id1[16];
	char	id2[16];

	memset( id1, 0, sizeof( id1 ));
	memset( id2, 0, sizeof( id2 ));

	_readvect( 0x41, 0, -4, id1 );
	_readvect( 0x42, 0, -4, id2 );

	if( memcmp( id1, "-KUN", 4 ) != 0 )
	{
		if( memcmp( id2, "-KUN", 4 ) != 0 )
		{
			printf( MES[MES_DRVNOTFOUND], DRIVER_name );
			return 1;
		} else SS_int = 0x42;
	} else SS_int = 0x41;

	printf( INFO[INFO_DRIVER], DRIVER_name );

	return 0;
}

int SS_load( char *filename )
{
	long	filesize;

	if( strcmpi( filename, OPT[OPT_LOOPOUT] ) == 0 )
	{
		SS_loopout();
		return 0;
	}

	if( strcmpi( filename, OPT[OPT_SSGPCM] ) == 0 )
	{
		SS_ssgpcm();
		return 0;
	}

	filesize = _filesize( filename );
	if( filesize == -1 ) return 1;

	/* Music : SI:DI */
	r.h.ah = 0x01;
	r.x.si = FP_SEG( filename );
	r.x.di = FP_OFF( filename );
	int86x( SS_int, &r, &ro, &sr );

	printf( INFO[INFO_LOAD], filename, filesize );

	return 0;
}

int SS_play( char *opt1, char *opt2 )
{
	return 0;
}

int SS_stop( void )
{
	r.h.ah = 0x02;
	int86x( SS_int, &r, &ro, &sr );

	return 0;
}

int SS_fade( void )
{
	r.h.ah = 0x03;
	r.h.dh = 0x30;
	r.h.dl = 0x00;
	int86x( SS_int, &r, &ro, &sr );

	return 0;
}

int SS_loopout( void )
{
	r.h.ah = 0x0C;
	r.h.al = 0x01;
	int86x( SS_int, &r, &ro, &sr );

	return 0;
}

int SS_ssgpcm( void )
{
	r.h.ah = 0x05;
	r.h.al = 0x00;
	int86x( SS_int, &r, &ro, &sr );

	return 0;
}
