#include <stdio.h>
#include <string.h>
#include <dos.h>
#include <memory.h>
#include <fcntl.h>

#include "sdn.h"
#include "..\common.h"
#include "..\extern.h"
#include "..\gmpv4sp.h"

char _asm_load();

int SDN_check( void )
{
	char	id[16];

	memset( id, 0, sizeof( id ));

	_readvect( 0x50, 0, 2, id );

	if( memcmp( id, "SQRVWU ", 6 ) != 0 )
	{
		printf( MES[MES_DRVNOTFOUND], DRIVER_name );
		return 1;
	}

	printf( INFO[INFO_DRIVER], DRIVER_name );

	return 0;
}

int SDN_load( char *filename )
{
	if( GMPV4SP_load( filename, 0, 1, 1 ) == -1 ) return 1;

	return 0;
}

int SDN_play( char *opt1, char *opt2 )
{
	GMPV4SP_address( &seg, &off, 1 );

	/* Music : ES:DI */
	r.x.ax = 0x0100;
	sr.es = seg;
	r.x.di = off;
	int86x( 0x50, &r, &ro, &sr );

	return 0;
}

int SDN_stop( void )
{
	r.h.ah = 0x05;
	int86x( 0x50, &r, &ro, &sr );

	return 0;
}

int SDN_fade( void )
{
	r.h.ah = 0x07;
	r.x.cx = 0x0019;
	r.h.dh = 0x0F;
	r.h.dl = 0x00;
	int86x( 0x50, &r, &ro, &sr );

	return 0;
}
